<?php
/**
 * The template for displaying search results pages.
 *
 * @package Square
 */
get_header();
?>
<header class="sq-main-header">
    <div class="sq-container">
        <h1 class="sq-main-title">
            <?php
            printf(
                    /* translators: Search Query */
                    esc_html__('Search Results for: %s', 'square'), '<span>' . get_search_query() . '</span>');
            ?>
        </h1>
    </div>
</header><!-- .sq-main-header -->

<div class="sq-container">
    <section id="primary" class="content-area">
        <main id="main" class="site-main" role="main">

            <?php if (have_posts()) : ?>

                <header class="page-header">

                </header><!-- .page-header -->

                <?php /* Start the Loop */ ?>
                <?php while (have_posts()) : the_post(); ?>

                    <?php
                    /**
                     * Run the loop for the search to output the results.
                     * If you want to overload this in a child theme then include a file
                     * called content-search.php and that will be used instead.
                     */
                    get_template_part('template-parts/content', 'search');
                    ?>

                <?php endwhile; ?>

                <?php the_posts_navigation(); ?>

            <?php else : ?>

                <?php get_template_part('template-parts/content', 'none'); ?>

            <?php endif; ?>

        </main><!-- #main -->
    </section><!-- #primary -->

    <?php get_sidebar(); ?>
</div>

<?php
get_footer();
